package PagePlus

import (
	"git.168cad.top/zhengqiuyun/rym-util/exception"
	"git.168cad.top/zhengqiuyun/rym-util/page"
	"git.168cad.top/zhengqiuyun/rym-util/util"
	"gorm.io/gorm"
)

func Page(params []page.Param, pageNum int, pageSize int, m interface{}, data interface{}, orderBy string, db *gorm.DB) *page.Data {
	var page = page.Data{}
	page.PageSize = util.If(pageSize == 0, 10, pageSize)
	page.PageNum = util.If(pageNum == 0, 1, pageNum)
	tx := db.Session(&gorm.Session{PrepareStmt: true})
	countTx := tx.Model(&m).Select("count(1)")
	if params != nil {
		for _, p := range params {
			countTx.Where(p.Column+" "+p.Op+" ?", p.Value)
		}
	}
	resultCount := countTx.Scan(&page.Total)
	if resultCount.Error != nil {
		exception.ThrowsErr(resultCount.Error)
	}
	if page.Total > 0 {
		dataTx := tx.Model(&m).Offset((page.PageNum - 1) * page.PageSize).Limit(page.PageSize).Order(orderBy)
		if params != nil {
			for _, p := range params {
				dataTx.Where(p.Column+" "+p.Op+" ?", p.Value)
			}
		}
		resultList := dataTx.Find(&data)
		if resultList.Error != nil {
			exception.ThrowsErr(resultList.Error)
		}
		page.List = data
	}
	return &page
}
